import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

class NavigationDrawer extends StatefulWidget {
  final DrawerParameters drawerParameters;
  NavigationDrawer({this.drawerParameters});

  @override
  _NavigationDrawerState createState() => _NavigationDrawerState();
}

class _NavigationDrawerState extends State<NavigationDrawer> {

  Widget buildHeader(){
    return (widget.drawerParameters.phone!=''||widget.drawerParameters.email!=''||widget.drawerParameters.name!=''||widget.drawerParameters.urlImage!='')?Container(
      padding: EdgeInsets.symmetric(vertical: 10),
      child: Column(
        children: [
          Row(
            children: [
              SizedBox(width: 30),
              (widget.drawerParameters.urlImage!='')?CircleAvatar(radius: 20, backgroundImage: NetworkImage(widget.drawerParameters.urlImage)):SizedBox(width: 20,),
              SizedBox(width: 20),
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  (widget.drawerParameters.name!='')?Text(widget.drawerParameters.name, style: TextStyle(fontSize: 20, color: Colors.black),):SizedBox.shrink(),
                  (widget.drawerParameters.name!='')?const SizedBox(height: 2):SizedBox.shrink(),
                  (widget.drawerParameters.email!='')?Text(widget.drawerParameters.email, style: TextStyle(fontSize: 14, color: Colors.black),):SizedBox.shrink(),
                  (widget.drawerParameters.email!='')?const SizedBox(height: 2):SizedBox.shrink(),
                  (widget.drawerParameters.phone!='')?Text(widget.drawerParameters.phone, style: TextStyle(fontSize: 14, color: Colors.black),):SizedBox.shrink(),
                ],
              ),
              Padding(
                padding: const EdgeInsets.only(left: 6,bottom: 50),
                child: GestureDetector(
                    onTap: (){
                      Navigator.pop(context);
                    },
                    child: Icon(Icons.clear,color: Colors.black,)),
              )
              //Spacer(),
            ],
          ),
          const SizedBox(height: 10),
          Padding(
            padding: const EdgeInsets.symmetric(horizontal: 30),
            child: Divider(color: Colors.grey, thickness: 0.5),
          ),
        ],
      ),
    ):SizedBox(
      height: 20,
      child: Padding(
        padding: const EdgeInsets.only(left: 210,top: 5),
        child: GestureDetector(
            onTap: (){
              Navigator.pop(context);
            },
            child: Icon(Icons.clear,color: Colors.black,)),
      ) ,
    );
  }

  Widget buildMenuItem({
    String text,
    IconData icon,
    Color  iconTextColor
  }) {
    final hoverColor = Colors.grey[300];
    return Padding(
      padding: const EdgeInsets.symmetric(horizontal: 20),
      child: (icon!=null)?ListTile(
        leading: Icon(icon, color: iconTextColor??Colors.black),
        title: Text(text, style: TextStyle(color: iconTextColor??Colors.black)),
        hoverColor: hoverColor,
        onTap: (){},
      ):ListTile(
        title: Text(text, style: TextStyle(color: iconTextColor??Colors.black)),
        hoverColor: hoverColor,
        onTap: (){},
      ),
    );
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      width: 250,
      child: Drawer(
        child: Material(
          color: widget.drawerParameters.drawerColor,
          child: ListView(
            children: [
              buildHeader(),
              (widget.drawerParameters.items!=null)?Container(
                child: Column(
                  children: [
                    const SizedBox(height: 12),
                    for(int i =0; i<widget.drawerParameters.items.length;i++)
                      for(var key in widget.drawerParameters.items[i].keys)
                        buildMenuItem(
                            text: key,
                            icon: widget.drawerParameters.items[i][key],
                            iconTextColor: widget.drawerParameters.iconTextColor
                        ),
                    SizedBox(height: 12),
                  ],
                ),
              ):SizedBox.shrink(),
            ],
          ),
        ),
      ),
    );
  }
}
